'1次元熱伝導計算の実行ﾌﾟﾛｸﾞﾗﾑ
Imports System.Drawing

Public Class Th1DCal3
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(160, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(160, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "熱伝導計算の実行"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(280, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(143, 196)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(144, 24)
        Me.PictureBox1.TabIndex = 6
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(143, 148)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(250, 22)
        Me.PictureBox2.TabIndex = 7
        Me.PictureBox2.TabStop = False
        '
        'Th1DCal3
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(514, 302)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Th1DCal3"
        Me.Text = "Th1DCal3"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim SwK As IO.StreamWriter  '結果出力用

    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置

    Dim KTempRange(2) As Integer    '最低・最高温度のﾒｯｼｭ番号（層左端:-2、層左端:-1） 
    Dim LTempRange(2) As Integer    '最低・最高温度の層番号 

    Dim Atherm(,) As Double     '各材料の温度伝導率
    Dim DxL() As Double         '各層ﾒｯｼｭ幅
    Dim Dx2L() As Double        '各層ﾒｯｼｭ幅の2乗
    Dim TempRange(2) As Single      '最低・最高温度
    Dim Tf() As Double          '差分計算の右辺ﾍﾞｸﾄﾙ
    Dim Tk(,) As Double         '差分行列
    Dim TTempRange(2) As Single     '最低・最高温度の時間
    Dim TUx() As Double         '前回の温度

    Private Sub BetLayer1(ByVal i As Integer, ByVal kb As Integer)
        '層間境界1の計算（層ﾒｯｼｭ最初）
        'i･･･層の番号
        'kb･･･変数の番号
        Dim ib, kdiv, kdivx, kdleft, kmat, kmatb As Integer
        Dim b1, b2, b3, b4, b5, b6, templeft, tempm, tempmx As Double
        tempm = Tu(kb)
        kmat = NumMat(i)
        Call StateCalc(kmat, kdiv, tempm)   '物性状態の計算
        tempmx = TUx(kb)
        Call StateCalc(kmat, kdivx, tempmx)   '物性状態の計算
        b1 = Atherm(kmat, kdiv) / (2 * Dx2L(i))
        b2 = Atherm(kmat, kdivx) / (2 * Dx2L(i))
        b3 = TUx(kb) / Dtime
        templeft = Tu(kb - 1)
        ib = i - 1
        kmatb = NumMat(ib)
        Call StateCalc(kmatb, kdleft, templeft)   '物性状態の計算
        b4 = Rlamda(kmatb, kdleft) / DxL(ib)
        b5 = Rlamda(kmat, kdiv) / DxL(i)
        Tk(kb, 1) = Tk(kb, 1) + 2 * b1 * b4 / (b4 + b5)
        Tk(kb, 2) = Tk(kb, 2) - 3 * b1 - 1 / Dtime + 2 * b1 * b5 / (b4 + b5)
        Tk(kb, 3) = Tk(kb, 3) + b1
        b6 = b2 * (TUx(kb + 1) - 3 * TUx(kb) + 2 * TempLB(i))
        Tf(kb) = Tf(kb) - b3 - b6
    End Sub

    Private Sub BetLayer1S(ByVal i As Integer, ByVal kb As Integer)
        '層間境界1の計算S（層ﾒｯｼｭ最初）
        'i･･･層の番号
        'kb･･･変数の番号
        Dim ib, kmat, kmatb As Integer
        Dim b1, b4, b5 As Double

        kmat = NumMat(i)
        b1 = Atherm(kmat, 1) / Dx2L(i)
        ib = i - 1
        kmatb = NumMat(ib)
        b4 = Rlamda(kmatb, 1) / DxL(ib)
        b5 = Rlamda(kmat, 1) / DxL(i)

        Tk(kb, 1) = Tk(kb, 1) + 2 * b1 * b4 / (b4 + b5)
        Tk(kb, 2) = Tk(kb, 2) - 3 * b1 + 2 * b1 * b5 / (b4 + b5)
        Tk(kb, 3) = Tk(kb, 3) + b1

    End Sub

    Private Sub BetLayer2(ByVal i As Integer, ByVal kb As Integer)
        '層間境界2の計算（層ﾒｯｼｭ最後）
        'i･･･層の番号
        'kb･･･変数の番号
        Dim ib, kdiv, kdivx, kdright, kmat, kmatb As Integer
        Dim b1, b2, b3, b4, b5, b6, tempm, tempmx, tempright As Double
        tempm = Tu(kb)
        kmat = NumMat(i)
        Call StateCalc(kmat, kdiv, tempm)   '物性状態の計算
        tempmx = TUx(kb)
        Call StateCalc(kmat, kdivx, tempmx)   '物性状態の計算
        b1 = Atherm(kmat, kdiv) / (2 * Dx2L(i))
        b2 = Atherm(kmat, kdivx) / (2 * Dx2L(i))
        b3 = TUx(kb) / Dtime
        tempright = Tu(kb + 1)
        ib = i + 1
        kmatb = NumMat(ib)
        Call StateCalc(kmatb, kdright, tempright)   '物性状態の計算
        b4 = Rlamda(kmatb, kdright) / DxL(ib)
        b5 = Rlamda(kmat, kdiv) / DxL(i)
        Tk(kb, 3) = Tk(kb, 3) + 2 * b1 * b4 / (b4 + b5)
        Tk(kb, 2) = Tk(kb, 2) - 3 * b1 - 1 / Dtime + 2 * b1 * b5 / (b4 + b5)
        Tk(kb, 1) = Tk(kb, 1) + b1
        b6 = b2 * (TUx(kb - 1) - 3 * TUx(kb) + 2 * TempLB(ib))
        Tf(kb) = Tf(kb) - b3 - b6
    End Sub

    Private Sub BetLayer2S(ByVal i As Integer, ByVal kb As Integer)
        '層間境界2の計算S（層ﾒｯｼｭ最後）
        'i･･･層の番号
        'kb･･･変数の番号
        Dim ib, kmat, kmatb As Integer
        Dim b1, b4, b5 As Double

        kmat = NumMat(i)
        b1 = Atherm(kmat, 1) / Dx2L(i)
        ib = i + 1
        kmatb = NumMat(ib)
        b4 = Rlamda(kmatb, 1) / DxL(ib)
        b5 = Rlamda(kmat, 1) / DxL(i)
        Tk(kb, 3) = Tk(kb, 3) + 2 * b1 * b4 / (b4 + b5)
        Tk(kb, 2) = Tk(kb, 2) - 3 * b1 + 2 * b1 * b5 / (b4 + b5)
        Tk(kb, 1) = Tk(kb, 1) + b1

    End Sub

    Private Sub Bound1Cal(ByVal istep As Integer)
        '境界1の計算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim kdiv, kdivx, kmat As Integer
        Dim b1, b2, b3, b4, b5, b6, tempm, tempmx, temps As Double
        tempm = Tu(1)
        kmat = NumMat(1)
        Call StateCalc(kmat, kdiv, tempm)   '物性状態の計算
        tempmx = TUx(1)
        Call StateCalc(kmat, kdivx, tempmx)   '物性状態の計算
        b1 = Atherm(kmat, kdiv) / (2 * Dx2L(1))
        b2 = Atherm(kmat, kdivx) / (2 * Dx2L(1))
        b3 = TUx(1) / Dtime
        b4 = b2 * (TUx(2) - 3 * TUx(1) + 2 * TempSurf(1))
        Tk(1, 3) = Tk(1, 3) + b1
        Select Case KindBoundL(istep)
            Case 0
                Tk(1, 2) = Tk(1, 2) - b1 - 1 / Dtime
                Tf(1) = Tf(1) - b3 - b2 * (TUx(2) - TUx(1))
            Case 1
                Tk(1, 2) = Tk(1, 2) - 3 * b1 - 1 / Dtime
                b5 = 2 * b1 * BoundDataL(istep, 1)
                Tf(1) = Tf(1) - b3 - b4 - b5
            Case 2
                b5 = 2 * Rlamda(kmat, kdiv) / DxL(1)
                b6 = BoundDataL(istep, 2) + b5
                Tk(1, 2) = Tk(1, 2) - 3 * b1 - 1 / Dtime + 2 * b1 * b5 / b6
                b5 = 2 * b1 * BoundDataL(istep, 2) * BoundDataL(istep, 1) / b6
                Tf(1) = Tf(1) - b3 - b4 - b5
            Case 3
                Tk(1, 2) = Tk(1, 2) - b1 - 1 / Dtime
                b5 = BoundDataL(istep, 1) / (2 * Rou(kmat) * Cspec(kmat, kdiv) * DxL(1))
                Tf(1) = Tf(1) - b3 - b4 + b5
            Case 4
                Tk(1, 2) = Tk(1, 2) - 3 * b1 - 1 / Dtime
                Call TsurfCalc(1, istep, temps)   '境界表面温度の計算
                b5 = 2 * b1 * temps
                Tf(1) = Tf(1) - b3 - b4 - b5
        End Select
    End Sub

    Private Sub Bound1CalS()
        '境界1の計算S
        Dim kmat As Integer
        Dim b1, b5, b6 As Double

        kmat = NumMat(1)
        b1 = Atherm(kmat, 1) / Dx2L(1)
        Tk(1, 3) = Tk(1, 3) + b1
        Select Case KindBoundL(1)
            Case 0
                Tk(1, 2) = Tk(1, 2) - b1
            Case 1
                Tk(1, 2) = Tk(1, 2) - 3 * b1
                b5 = 2 * b1 * BoundDataL(1, 1)
                Tf(1) = Tf(1) - b5
            Case 2
                b5 = 2 * Rlamda(kmat, 1) / DxL(1)
                b6 = BoundDataL(1, 2) + b5
                Tk(1, 2) = Tk(1, 2) - 3 * b1 + 2 * b1 * b5 / b6
                b5 = 2 * b1 * BoundDataL(1, 2) * BoundDataL(1, 1) / b6
                Tf(1) = Tf(1) - b5
            Case 3
                Tk(1, 2) = Tk(1, 2) - b1
                b5 = BoundDataL(1, 1) / (Rou(kmat) * Cspec(kmat, 1) * DxL(1))
                Tf(1) = Tf(1) + b5
        End Select

    End Sub

    Private Sub Bound2Cal(ByVal istep As Integer)
        '境界2の計算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim kdiv, kdivx, kmat As Integer
        Dim b1, b2, b3, b4, b5, b6, tempm, tempmx, temps As Double
        tempm = Tu(Nall)
        kmat = NumMat(NL)
        Call StateCalc(kmat, kdiv, tempm)  '物性状態の計算
        tempmx = TUx(Nall)
        Call StateCalc(kmat, kdivx, tempmx)   '物性状態の計算
        b1 = Atherm(kmat, kdiv) / (2 * Dx2L(NL))
        b2 = Atherm(kmat, kdivx) / (2 * Dx2L(NL))
        b3 = TUx(Nall) / Dtime
        b4 = b2 * (TUx(Nall - 1) - 3 * TUx(Nall) + 2 * TempSurf(2))
        Tk(Nall, 1) = Tk(Nall, 1) + b1
        Select Case KindBoundR(istep)
            Case 0
                Tk(Nall, 2) = Tk(Nall, 2) - b1 - 1 / Dtime
                Tf(Nall) = Tf(Nall) - b3 - b2 * (TUx(Nall - 1) - TUx(Nall))
            Case 1
                Tk(Nall, 2) = Tk(Nall, 2) - 3 * b1 - 1 / Dtime
                b5 = 2 * b1 * BoundDataR(istep, 1)
                Tf(Nall) = Tf(Nall) - b3 - b4 - b5
            Case 2
                b5 = 2 * Rlamda(kmat, kdiv) / DxL(NL)
                b6 = BoundDataR(istep, 2) + b5
                Tk(Nall, 2) = Tk(Nall, 2) - 3 * b1 - 1 / Dtime + 2 * b1 * b5 / b6
                b5 = 2 * b1 * BoundDataR(istep, 2) * BoundDataR(istep, 1) / b6
                Tf(Nall) = Tf(Nall) - b3 - b4 - b5
            Case 3
                Tk(Nall, 2) = Tk(Nall, 2) - b1 - 1 / Dtime
                b5 = BoundDataR(istep, 1) / (2 * Rou(kmat) * Cspec(kmat, kdiv) * DxL(NL))
                Tf(Nall) = Tf(Nall) - b3 - b4 + b5
            Case 4
                Tk(Nall, 2) = Tk(Nall, 2) - 3 * b1 - 1 / Dtime
                Call TsurfCalc(2, istep, temps)   '境界表面温度の計算
                b5 = 2 * b1 * temps
                Tf(Nall) = Tf(Nall) - b3 - b4 - b5
        End Select
    End Sub

    Private Sub Bound2CalS()
        '境界2の計算S
        Dim kmat As Integer
        Dim b1, b5, b6 As Double

        kmat = NumMat(NL)
        b1 = Atherm(kmat, 1) / Dx2L(NL)
        Tk(Nall, 1) = Tk(Nall, 1) + b1
        Select Case KindBoundR(1)
            Case 0
                Tk(Nall, 2) = Tk(Nall, 2) - b1
            Case 1
                Tk(Nall, 2) = Tk(Nall, 2) - 3 * b1
                b5 = 2 * b1 * BoundDataR(1, 1)
                Tf(Nall) = Tf(Nall) - b5
            Case 2
                b5 = 2 * Rlamda(kmat, 1) / DxL(NL)
                b6 = BoundDataR(1, 2) + b5
                Tk(Nall, 2) = Tk(Nall, 2) - 3 * b1 + 2 * b1 * b5 / b6
                b5 = 2 * b1 * BoundDataR(1, 2) * BoundDataR(1, 1) / b6
                Tf(Nall) = Tf(Nall) - b5
            Case 3
                Tk(Nall, 2) = Tk(Nall, 2) - b1
                b5 = BoundDataR(1, 1) / (Rou(kmat) * Cspec(kmat, 1) * DxL(NL))
                Tf(Nall) = Tf(Nall) + b5
        End Select

    End Sub

    Private Sub BoundCalc(ByVal istep As Integer)
        '各境界温度の計算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim i, ib, kb, kdiv, kmat As Integer
        Dim b1, bn, temp1, tempn, temps As Double
        For ib = 1 To 2
            Call TsurfCalc(ib, istep, temps)   '境界表面温度の計算
            TempSurf(ib) = temps
        Next ib
        If NL > 1 Then
            For i = 2 To NL
                kb = KstartL(i)
                tempn = Tu(kb - 1)
                ib = i - 1
                kmat = NumMat(ib)
                Call StateCalc(kmat, kdiv, tempn)   '物性状態の計算
                bn = Rlamda(kmat, kdiv) / DxL(ib)
                temp1 = Tu(kb)
                kmat = NumMat(i)
                Call StateCalc(kmat, kdiv, temp1)   '物性状態の計算
                b1 = Rlamda(kmat, kdiv) / DxL(i)
                TempLB(i) = (bn * tempn + b1 * temp1) / (bn + b1)
            Next i
        End If

    End Sub

    Private Sub BoundCalcS()
        '各境界温度の計算S
        Dim i, ib, kb, kmat As Integer
        Dim b1, bn, temp1, tempn, temps As Double
        For ib = 1 To 2
            Call TsurfCalcS(ib, temps)   '境界表面温度の計算S
            TempSurf(ib) = temps
        Next ib
        If NL > 1 Then
            For i = 2 To NL
                kb = KstartL(i)
                tempn = Tu(kb - 1)
                ib = i - 1
                kmat = NumMat(ib)
                bn = Rlamda(kmat, 1) / DxL(ib)
                temp1 = Tu(kb)
                kmat = NumMat(i)
                b1 = Rlamda(kmat, 1) / DxL(i)
                TempLB(i) = (bn * tempn + b1 * temp1) / (bn + b1)
            Next i
        End If

    End Sub

    Private Sub ConvCheck(ByRef icc As Integer, ByRef dtemp As Single)
        '収束ﾁｪｯｸ
        'icc･･･収束の有無（0:なし、1:有り）
        'dtemp･･･温度の最大変化量
        Dim i As Integer
        Dim b1, dtempstd As Single
        dtempstd = 0.1 * DtempMax
        '計算1回の許容最大変化量の1割を収束判定基準とする

        dtemp = 0
        For i = 1 To Nall
            b1 = Math.Abs(Tf(i) - Tu(i))
            If b1 > dtemp Then
                dtemp = b1
            End If
        Next i
        If dtemp > dtempstd Then
            icc = 0
        Else
            icc = 1
        End If

    End Sub

    Private Sub Debug1(ByVal mb As Integer)
        '差分行列のデバッグ
        'mb･･･ﾌﾙﾊﾞﾝﾄﾞ幅
        Dim aa$, fxx$
        Dim i, ic, j, j1, j2, jb, mh As Integer
        Dim z1 As Single

        mh = (mb + 1) / 2
        aa$ = ""
        fxx$ = DirOpen$ + "\Therm1DDebug1.dat"
        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "フルバンド幅" + ",  " + Str(mb)
        sw.WriteLine(aa$)
        For i = 1 To Nall
            aa$ = "行番号" + ",  " + Str(i)
            sw.WriteLine(aa$)

            j1 = i - mh + 1
            If j1 < 1 Then
                j1 = 1
            End If
            j2 = i + mh - 1
            If j2 > Nall Then
                j2 = Nall
            End If
            ic = 0
            For j = j1 To j2
                jb = j - i + mh
                z1 = Tk(i, jb)
                If z1 <> 0 Then
                    If ic = 0 Then
                        aa$ = Str$(j) + ",  " + Str$(z1)
                    Else
                        aa$ = aa$ + ",    " + Str$(j) + ",  " + Str$(z1)
                    End If
                    If ic = 4 Then
                        sw.WriteLine(aa$)
                        ic = 0
                    Else
                        ic = ic + 1
                    End If
                End If
            Next j
            If ic > 0 Then
                sw.WriteLine(aa$)
            End If
            z1 = Tf(i)
            aa$ = "    右辺" + ",  " + Str(z1)
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        Stop

    End Sub

    Private Sub DifMatrix(ByVal istep As Integer, ByVal mb As Integer)
        '差分行列作成
        'istep･･･ｽﾃｯﾌﾟ番号
        'mb･･･ﾌﾙﾊﾞﾝﾄﾞ幅
        Dim i, j, jmax, kb, kbase As Integer
        For i = 1 To Nall
            For j = 1 To mb
                Tk(i, j) = 0
            Next j
            Tf(i) = 0
        Next i
        For i = 1 To NL
            kbase = KstartL(i)
            jmax = Mesh(i)
            For j = 1 To jmax
                kb = kbase + j - 1
                If j = 1 Then
                    If i = 1 Then
                        Call Bound1Cal(istep)    '境界1の計算
                    Else
                        Call BetLayer1(i, kb)  '層間境界1の計算
                    End If
                ElseIf j = jmax Then
                    If i = NL Then
                        Call Bound2Cal(istep)    '境界2の計算
                    Else
                        Call BetLayer2(i, kb) '層間境界2の計算
                    End If
                Else
                    Call MeshCalc(i, kb)   '通常ﾒｯｼｭの計算
                End If
            Next j
        Next i

    End Sub

    Private Sub DifMatrixS(ByVal mb As Integer)
        '差分行列作成S
        'mb･･･ﾌﾙﾊﾞﾝﾄﾞ幅
        Dim i, istep, j, jmax, kb, kbase As Integer

        istep = 1
        For i = 1 To Nall
            For j = 1 To mb
                Tk(i, j) = 0
            Next j
            Tf(i) = 0
        Next i
        For i = 1 To NL
            kbase = KstartL(i)
            jmax = Mesh(i)
            For j = 1 To jmax
                kb = kbase + j - 1
                If j = 1 Then
                    If i = 1 Then
                        Call Bound1CalS()    '境界1の計算S
                    Else
                        Call BetLayer1S(i, kb)  '層間境界1の計算S
                    End If
                ElseIf j = jmax Then
                    If i = NL Then
                        Call Bound2CalS()    '境界2の計算S
                    Else
                        Call BetLayer2S(i, kb) '層間境界2の計算S
                    End If
                Else
                    Call MeshCalcS(i, kb)   '通常ﾒｯｼｭの計算S
                End If
            Next j
        Next i

    End Sub

    Private Sub DtempCalc(ByRef dtempx As Double)
        '最大温度変化の計算
        'dtempx･･･最大温度変化値
        Dim i As Integer
        Dim b1 As Double
        dtempx = 0
        For i = 1 To Nall
            b1 = Math.Abs(Tu(i) - TUx(i))
            If b1 > dtempx Then
                dtempx = b1
            End If
        Next i
    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ie, j, kmat As Integer
        Dim b1, b2 As Single
        ReDim KstartL(NL), DxL(NL), Dx2L(NL), TempLB(NL)

        ie = 1
        Nall = 0
        For i = 1 To NL
            KstartL(i) = ie
            Nall = Nall + Mesh(i)
            ie = ie + Mesh(i)
        Next i
        ReDim Tf(Nall), Tu(Nall), TUx(Nall)

        ReDim Atherm(Nmat, NMdivMax)
        For i = 1 To Nmat
            For j = 1 To NMdiv(i)
                Atherm(i, j) = Rlamda(i, j) / (Rou(i) * Cspec(i, j))
            Next j
        Next i

        ie = 0
        For i = 1 To NL
            DxL(i) = Rlength(i) / Mesh(i)
            Dx2L(i) = DxL(i) * DxL(i)
        Next i

        If InitData > 0 Then
            ie = 0
            For i = 1 To NL
                For j = 1 To Mesh(i)
                    ie = ie + 1
                    Tu(ie) = TempInit(i, j)
                Next j
            Next i
        End If

        If Mstat > 0 Then
            ie = 0
            For i = 1 To NL
                For j = 1 To Mesh(i)
                    ie = ie + 1
                    TUx(ie) = Tu(ie)
                Next j

                GoTo Skip10
                kmat = NumMat(i)
                For j = 1 To NMdiv(kmat)
                    b1 = Atherm(kmat, j)
                    If j = 0 Then
                        b2 = b1
                    ElseIf b1 > b2 Then
                        b2 = b1
                    End If
                Next j
                b1 = Dx2L(i) / b2
Skip10:
            Next i

            '境界表面温度の仮設定
            TempSurf(1) = Tu(1)
            TempSurf(2) = Tu(Nall)
            Call BoundCalc(1)    '各境界温度の計算
        End If

    End Sub

    Private Sub MeshCalc(ByVal i As Integer, ByVal kb As Integer)
        '通常ﾒｯｼｭの計算
        'i･･･層の番号
        'kb･･･変数番号
        Dim kdiv, kdivx, kmat As Integer
        Dim b1, b2, b3, b6, tempm, tempmx As Double
        tempm = Tu(kb)
        kmat = NumMat(i)
        Call StateCalc(kmat, kdiv, tempm)   '物性状態の計算
        tempmx = TUx(kb)
        Call StateCalc(kmat, kdivx, tempmx)   '物性状態の計算
        b1 = Atherm(kmat, kdiv) / (2 * Dx2L(i))
        b2 = Atherm(kmat, kdivx) / (2 * Dx2L(i))
        b3 = TUx(kb) / Dtime
        Tk(kb, 1) = Tk(kb, 1) + b1
        Tk(kb, 2) = Tk(kb, 2) - 2 * b1 - 1 / Dtime
        Tk(kb, 3) = Tk(kb, 3) + b1
        b6 = b2 * (TUx(kb + 1) - 2 * TUx(kb) + TUx(kb - 1))
        Tf(kb) = Tf(kb) - b3 - b6

    End Sub

    Private Sub MeshCalcS(ByVal i As Integer, ByVal kb As Integer)
        '通常ﾒｯｼｭの計算
        'i･･･層の番号
        'kb･･･変数番号
        Dim kmat As Integer
        Dim b1 As Double

        kmat = NumMat(i)
        b1 = Atherm(kmat, 1) / Dx2L(i)
        Tk(kb, 1) = Tk(kb, 1) + b1
        Tk(kb, 2) = Tk(kb, 2) - 2 * b1
        Tk(kb, 3) = Tk(kb, 3) + b1

    End Sub

    Private Sub RadFunc(ByVal alp As Double, ByVal dx As Double, _
        ByVal rlam As Double, ByRef sf As Double, _
        ByVal tempe As Double, ByVal tempmesh As Double, _
        ByVal temps As Double)
        '初期の熱放射関数値計算
        'alp･･･放射係数
        'dx･･･ﾒｯｼｭ幅
        'rlam･･･熱伝導率
        'sf･･･関数値
        'tempe･･･外の温度
        'tempmesh･･･ﾒｯｼｭ温度
        'temps･･･表面温度
        Dim b1, b2 As Double
        b1 = alp * (temps ^ 4 - tempe ^ 4)
        b2 = 2 * rlam * (tempmesh - temps) / dx
        sf = Math.Abs(b1 - b2)
    End Sub

    Private Sub ReqTime(ByVal rmesh As Single, ByVal rmeshsum As Single, _
        ByVal b1 As Double, ByVal b2 As Single)
        '残りの所要時間の計算
        'rmesh･･･ﾒｯｼｭ番号
        'rmeshsum･･･最大ﾒｯｼｭ番号
        'b1･･･熱伝導の時間差
        'b2･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b3, b4 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        tima$ = ""
        If b2 < 0 Then
            b2 = b2 + 86400
        End If
        b3 = rmeshsum - rmesh
        b3 = TimeMax * b3 / rmeshsum
        b4 = b2 * b3 / b1
        Call TimConv(tima$, b4)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$, c1$, c2$, c3$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        c1$ = "＜＜１次元熱伝導解析の計算結果＞＞"
        SwK.WriteLine(c1$)
        SwK.WriteLine(Title$)
        c1$ = "［入力データファイル］"
        aa$ = c1$ + "," + Fm$
        SwK.WriteLine(aa$)

        aa$ = "解析種類（0:定常、1:非定常）" + "," + Str(Mstat)
        SwK.WriteLine(aa$)
        If Mstat > 0 Then
            If Nstep = 1 Then
                c1$ = "計算打切り時間"
                c2$ = "    出力時間メッシュ数"
                aa$ = c1$ + "," + Str(TimeMax) + "," + c2$ + "," + Str(Ntime)
                SwK.WriteLine(aa$)
            Else
                c1$ = "計算サイクル数"
                c2$ = "    出力サイクル間隔"
                c3$ = "境界条件のステップ数"
                aa$ = c1$ + "," + Str(Ncycle) + "," + c2$ + "," + Str(Idcycle)
                SwK.WriteLine(aa$)
                aa$ = c3$ + "," + Str(Nstep)
                SwK.WriteLine(aa$)
            End If
            c1$ = "計算時間間隔の初期値"
            c2$ = "    計算１回の温度変化許容値"
            aa$ = c1$ + "," + Str(DtimeInit) + "," + c2$ + "," + Str(DtempMax)
            SwK.WriteLine(aa$)
        End If
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile3SU()
        '結果ﾌｧｲﾙへの出力3S
        'UTF-8･･･BOMなし
        Dim aa$
        Dim i, i1, ic, j, kb As Integer
        Dim b1, b2, z As Single

        ic = 1
        b1 = TempSurf(1)
        i1 = Int(b1)
        b2 = b1 - i1
        z = CInt(b2 * 100) / 100 + i1
        aa$ = "＜境界番号、表面温度＞" + ",   1" + ",  " + Str$(z)
        SwK.WriteLine(aa$)
        If ic > 0 Then
            LTempRange(1) = 1
            LTempRange(2) = 1
            KTempRange(1) = -2
            KTempRange(2) = -2
            TempRange(1) = z
            TempRange(2) = z
            ic = 0
        ElseIf z < TempRange(1) Then
            LTempRange(1) = 1
            KTempRange(1) = -2
            TempRange(1) = z
        ElseIf z > TempRange(2) Then
            LTempRange(2) = 1
            KTempRange(2) = -2
            TempRange(2) = z
        End If

        kb = 0
        For i = 1 To NL
            aa$ = "＜層番号＞" + ",  " + Str$(i)
            SwK.WriteLine(aa$)
            SwK.WriteLine("（メッシュ番号、温度）")
            For j = 1 To Mesh(i)
                kb = kb + 1
                b1 = Tu(kb)
                i1 = Int(b1)
                b2 = b1 - i1
                z = CInt(b2 * 100) / 100 + i1
                aa$ = "  " + Str$(j) + ",  " + Str$(z)
                SwK.WriteLine(aa$)
                If z < TempRange(1) Then
                    LTempRange(1) = i
                    KTempRange(1) = j
                    TempRange(1) = z
                ElseIf z > TempRange(2) Then
                    LTempRange(2) = i
                    KTempRange(2) = j
                    TempRange(2) = z
                End If
            Next j
        Next i

        b1 = TempSurf(2)
        i1 = Int(b1)
        b2 = b1 - i1
        z = CInt(b2 * 100) / 100 + i1
        aa$ = "＜境界番号、表面温度＞" + ",   2" + ",  " + Str$(z)
        SwK.WriteLine(aa$)
        If z < TempRange(1) Then
            LTempRange(1) = NL
            KTempRange(1) = -1
            TempRange(1) = z
            TTempRange(1) = TimeNew
        ElseIf z > TempRange(2) Then
            LTempRange(2) = NL
            KTempRange(2) = -1
            TempRange(2) = z
            TTempRange(2) = TimeNew
        End If


        If NL > 1 Then
            SwK.WriteLine("＜層間温度＞")
            For i = 2 To NL
                b1 = TempLB(i)
                i1 = Int(b1)
                b2 = b1 - i1
                z = CInt(b2 * 100) / 100 + i1
                aa$ = "  層" + Str$(i - 1) + "・" + Str$(i) + ",  " + Str$(z)
                SwK.WriteLine(aa$)
                If z < TempRange(1) Then
                    LTempRange(1) = i - 1
                    KTempRange(1) = -1
                    TempRange(1) = z
                ElseIf z > TempRange(2) Then
                    LTempRange(2) = i - 1
                    KTempRange(2) = -1
                    TempRange(2) = z
                End If
            Next i
        End If
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile3U(ByVal itime As Integer, ByVal icycle As Integer,
        ByVal istep As Integer)
        '結果ﾌｧｲﾙへの出力3
        'UTF-8･･･BOMなし
        'itime･･･時間ﾒｯｼｭ番号
        'icycle･･･ｻｲｸﾙ番号
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim aa$
        Dim i, i1, ic, j, kb As Integer
        Dim b1, b2, z As Single

        If Nstep = 1 Then
            aa$ = "＜時間メッシュ番号、時間＞" + ",  " + Str(itime) + ",  " + Str(TimeNew)
            SwK.WriteLine(aa$)
        Else
            aa$ = "＜サイクル番号、ステップ番号、時間＞" + ",  " + Str(icycle) + ",  " + Str(istep)
            aa$ = aa$ + ",  " + Str(TimeNew)
            SwK.WriteLine(aa$)
        End If

        ic = 0
        If TimeNew = 0 Then
            ic = 1
        End If

        b1 = TempSurf(1)
        i1 = Int(b1)
        b2 = b1 - i1
        z = CInt(b2 * 100) / 100 + i1
        aa$ = "＜境界番号、表面温度＞" + ",   1" + ",  " + Str$(z)
        SwK.WriteLine(aa$)
        If ic > 0 Then
            LTempRange(1) = 1
            LTempRange(2) = 1
            KTempRange(1) = -2
            KTempRange(2) = -2
            TempRange(1) = z
            TempRange(2) = z
            TTempRange(1) = 0
            TTempRange(2) = 0
            ic = 0
        ElseIf z < TempRange(1) Then
            LTempRange(1) = 1
            KTempRange(1) = -2
            TempRange(1) = z
            TTempRange(1) = TimeNew
        ElseIf z > TempRange(2) Then
            LTempRange(2) = 1
            KTempRange(2) = -2
            TempRange(2) = z
            TTempRange(2) = TimeNew
        End If

        kb = 0
        For i = 1 To NL
            aa$ = "＜層番号＞" + ",  " + Str$(i)
            SwK.WriteLine(aa$)
            SwK.WriteLine("（メッシュ番号、温度）")
            For j = 1 To Mesh(i)
                kb = kb + 1
                b1 = Tu(kb)
                i1 = Int(b1)
                b2 = b1 - i1
                z = CInt(b2 * 100) / 100 + i1
                aa$ = "  " + Str$(j) + ",  " + Str$(z)
                SwK.WriteLine(aa$)
                If z < TempRange(1) Then
                    LTempRange(1) = i
                    KTempRange(1) = j
                    TempRange(1) = z
                    TTempRange(1) = TimeNew
                ElseIf z > TempRange(2) Then
                    LTempRange(2) = i
                    KTempRange(2) = j
                    TempRange(2) = z
                    TTempRange(2) = TimeNew
                End If
            Next j
        Next i

        b1 = TempSurf(2)
        i1 = Int(b1)
        b2 = b1 - i1
        z = CInt(b2 * 100) / 100 + i1
        aa$ = "＜境界番号、表面温度＞" + ",   2" + ",  " + Str$(z)
        SwK.WriteLine(aa$)
        If z < TempRange(1) Then
            LTempRange(1) = NL
            KTempRange(1) = -1
            TempRange(1) = z
            TTempRange(1) = TimeNew
        ElseIf z > TempRange(2) Then
            LTempRange(2) = NL
            KTempRange(2) = -1
            TempRange(2) = z
            TTempRange(2) = TimeNew
        End If

        If NL > 1 Then
            SwK.WriteLine("＜層間温度＞")
            For i = 2 To NL
                b1 = TempLB(i)
                i1 = Int(b1)
                b2 = b1 - i1
                z = CInt(b2 * 100) / 100 + i1
                aa$ = "  層" + Str$(i - 1) + "・" + Str$(i) + ",  " + Str$(z)
                SwK.WriteLine(aa$)
                If z < TempRange(1) Then
                    LTempRange(1) = i - 1
                    KTempRange(1) = -1
                    TempRange(1) = z
                    TTempRange(1) = TimeNew
                ElseIf z > TempRange(2) Then
                    LTempRange(2) = i - 1
                    KTempRange(2) = -1
                    TempRange(2) = z
                    TTempRange(2) = TimeNew
                End If
            Next i
        End If
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile4SU()
        '結果ﾌｧｲﾙへの出力4S
        Dim a1$, aa$
        Dim i As Integer

        SwK.WriteLine("＜最低・最高温度データ＞")
        aa$ = "注）メッシュ番号の記号　 L：層左端、 R：層右端"
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最低・最高温度データ＞" + Chr(13) + Chr(10) + aa$
        aa$ = "変数項目、  値、              層番号、メッシュ番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        For i = 1 To 2
            Select Case i
                Case 1
                    aa$ = "TempMin"
                Case 2
                    aa$ = "TempMax"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(12 - Len(aa$)) + Str$(TempRange(i)) + ",  "
            aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(LTempRange(i)) + ",  "
            If KTempRange(i) = -2 Then
                a1$ = " L"
            ElseIf KTempRange(i) = -1 Then
                a1$ = " R"
            Else
                a1$ = Str$(KTempRange(i))
            End If
            aa$ = aa$ + Space$(46 - Len(aa$)) + a1$
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        Next i

    End Sub

    Private Sub ResFile4U()
        '結果ﾌｧｲﾙへの出力4
        'UTF-8･･･BOMなし
        Dim a1$, aa$
        Dim i As Integer

        SwK.WriteLine("＜最低・最高温度データ＞")
        aa$ = "注）メッシュ番号の記号　 L：層左端、 R：層右端"
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最低・最高温度データ＞" + Chr(13) + Chr(10) + aa$
        aa$ = "変数項目、  値、              層番号、メッシュ番号、 時間"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        For i = 1 To 2
            Select Case i
                Case 1
                    aa$ = "TempMin"
                Case 2
                    aa$ = "TempMax"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(12 - Len(aa$)) + Str$(TempRange(i)) + ",  "
            aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(LTempRange(i)) + ",  "
            If KTempRange(i) = -2 Then
                a1$ = " L"
            ElseIf KTempRange(i) = -1 Then
                a1$ = " R"
            Else
                a1$ = Str$(KTempRange(i))
            End If
            aa$ = aa$ + Space$(46 - Len(aa$)) + a1$ + ",  "
            aa$ = aa$ + Space$(54 - Len(aa$)) + Str$(TTempRange(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        Next i

    End Sub

    Private Sub RtempCalc(ByVal alp As Double, ByVal dx As Double, _
        ByVal rlam As Double, ByVal tempe As Double, _
        ByVal tempmesh As Double, ByRef temps As Double)
        '熱放射境界の表面温度計算（ＫＨ法最適化）
        'alp･･･放射係数
        'dx･･･ﾒｯｼｭ幅
        'rlam･･･熱伝導率
        'tempe･･･外の温度
        'tempmesh･･･ﾒｯｼｭ温度
        'temps･･･表面温度
        Dim ichange, j, k, kmax, knew As Integer
        Dim b1, b2, cinc, cred, drat, dt, dtbuf, eps As Double
        Dim s0, sf, sfm, tb, tmbuf, xm As Double
        cinc = 3    '増倍率
        cred = 0.2  '低減率
        drat = 0.1  '初期変化比率
        eps = 0.1 * DtempMax    '最小変化量（許容誤差）
        kmax = 10   '最大繰返し数
        k = 0
        Call RadFunc(alp, dx, rlam, s0, tempe, tempmesh, temps)
        '初期の熱放射関数値計算
        sfm = s0

        Do
            knew = 0    '変数の中心値Tと変化ΔTの更新有無
            k = k + 1   '繰返し回数加算
            tb = temps
            xm = tb
            dt = tb * drat
            If Math.Abs(dt) < eps Then  'dtが0になるのを防止
                dt = eps
            End If
            If k = 1 Or xm <> tmbuf Or dt <> dtbuf Then
                knew = 1
            End If
            tmbuf = xm
            dtbuf = dt

            ichange = 0         '各変数での改善有無
            For j = 1 To 2      '変数値の±ΔTで改善比較
                If j = 1 Then
                    temps = tb - dt
                Else
                    temps = tb + dt
                End If
                Call RadFunc(alp, dx, rlam, sf, tempe, tempmesh, temps)
                '熱放射関数値計算

                If sf < sfm Then        '最小化
                    ichange = 1
                    sfm = sf
                    xm = temps
                End If
            Next j
            temps = xm
            If ichange > 0 Then     '改善有りの場合はΔT比率を増倍
                drat = cinc * drat
            Else        '改善なしの場合はΔT比率を低減
                b1 = drat
                drat = cred * b1
                b2 = Math.Abs(temps * drat)

                'ΔTは最小変化量以上とする
                If b2 < eps Then
                    drat = b1
                End If
            End If
        Loop While k < kmax And knew = 1

    End Sub

    Private Sub Solver1(ByVal mh As Integer, ByVal nx As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･全変数の数
        Dim c1$, c2$
        Dim i, it, j, jj, jt, k, mx As Integer
        Dim b1 As Double
        For k = 1 To nx - 1
            mx = mh
            If k + mh - 1 > nx Then
                mx = nx - k + 1
            End If
            b1 = Tk(k, mh)
            If b1 = 0 Then
                c1$ = "計算実行エラー"
                c2$ = "変数番号" + LTrim$(Str$(k)) + "で"
                c2$ = c2$ + "ピボット変数が０になりました。"
                MsgBox(c2$, 0, c1$)
                End
            End If
            For j = 2 To mx
                jj = mh + j - 1
                Tk(k, jj) = Tk(k, jj) / b1
            Next j
            Tf(k) = Tf(k) / b1
            For i = 2 To mx
                it = i + k - 1
                jj = mh - i + 1
                b1 = Tk(it, jj)
                If b1 <> 0 Then
                    For j = 2 To mx
                        jt = j - i + mh
                        jj = mh + j - 1
                        Tk(it, jt) = Tk(it, jt) - b1 * Tk(k, jj)
                    Next j
                    Tf(it) = Tf(it) - b1 * Tf(k)
                End If
            Next i
        Next k
    End Sub

    Private Sub Solver2(ByVal mh As Integer, ByVal nx As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･全変数の数
        Dim j, jj, jt, k, mx As Integer
        Dim s As Double
        For k = nx - 1 To 1 Step -1
            s = 0
            mx = mh
            If k + mh - 1 > nx Then
                mx = nx - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                jj = mh + j - 1
                s = s + Tk(k, jj) * Tf(jt)
            Next j
            Tf(k) = Tf(k) - s
        Next k
    End Sub

    Private Sub StateCalc(ByVal kmat As Integer, ByRef kdiv As Integer, _
        ByVal tempmesh As Double)
        '物性状態の計算
        'kmat･･･材料番号
        'kdiv･･･物性区分番号
        'tempmesh･･･現在温度
        Dim i As Integer
        For i = 1 To NMdiv(kmat)
            kdiv = i
            If tempmesh <= TempMat(kmat, i) Then
                Exit For
            End If
        Next i
    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub TsurfCalc(ByVal ib As Integer, ByVal istep As Integer, ByRef temps As Double)
        '境界表面温度の計算
        'ib･･･境界番号（1または2）
        'istep･･･ｽﾃｯﾌﾟ番号
        'temps･･･境界表面温度
        Dim kb, kdiv, klayer, kmat As Integer
        Dim alp, b1, b2, b3, dx, rlam, tempe, tempmesh As Double
        If ib = 1 Then
            klayer = 1
            tempmesh = Tu(1)
            kb = KindBoundL(istep)
        Else
            klayer = NL
            tempmesh = Tu(Nall)
            kb = KindBoundR(istep)
        End If

        Select Case kb
            Case 0  '断熱
                temps = tempmesh
            Case 1  '温度固定
                If ib = 1 Then
                    temps = BoundDataL(istep, 1)
                Else
                    temps = BoundDataR(istep, 1)
                End If
            Case 2  '熱伝達
                kmat = NumMat(klayer)
                Call StateCalc(kmat, kdiv, tempmesh)   '物性状態の計算
                b1 = 2 * Rlamda(kmat, kdiv) / DxL(klayer)
                If ib = 1 Then
                    b2 = BoundDataL(istep, 2) * BoundDataL(istep, 1) + b1 * tempmesh
                    b3 = BoundDataL(istep, 2) + b1
                Else
                    b2 = BoundDataR(istep, 2) * BoundDataR(istep, 1) + b1 * tempmesh
                    b3 = BoundDataR(istep, 2) + b1
                End If
                temps = b2 / b3
            Case 3  '熱流束
                kmat = NumMat(klayer)
                Call StateCalc(kmat, kdiv, tempmesh)   '物性状態の計算
                If ib = 1 Then
                    b1 = BoundDataL(istep, 1)
                Else
                    b1 = BoundDataR(istep, 1)
                End If
                temps = tempmesh - b1 * DxL(klayer) / (2 * Rlamda(kmat, kdiv))
            Case 4  '熱放射
                kmat = NumMat(klayer)
                Call StateCalc(kmat, kdiv, tempmesh)   '物性状態の計算
                If ib = 1 Then
                    alp = BoundDataL(istep, 2)
                    tempe = BoundDataL(istep, 1)
                Else
                    alp = BoundDataR(istep, 2)
                    tempe = BoundDataR(istep, 1)
                End If
                rlam = Rlamda(kmat, kdiv)
                dx = DxL(klayer)
                temps = TempSurf(ib)
                Call RtempCalc(alp, dx, rlam, tempe, tempmesh, temps)
                '熱放射境界の表面温度計算
        End Select
    End Sub

    Private Sub TsurfCalcS(ByVal ib As Integer, ByRef temps As Double)
        '境界表面温度の計算
        'ib･･･境界番号（1または2）
        'temps･･･境界表面温度
        Dim kb, klayer, kmat As Integer
        Dim b1, b2, b3, tempmesh As Double

        If ib = 1 Then
            klayer = 1
            tempmesh = Tu(1)
            kb = KindBoundL(1)
        Else
            klayer = NL
            tempmesh = Tu(Nall)
            kb = KindBoundR(1)
        End If

        Select Case kb
            Case 0  '断熱
                temps = tempmesh
            Case 1  '温度固定
                If ib = 1 Then
                    temps = BoundDataL(1, 1)
                Else
                    temps = BoundDataR(1, 1)
                End If
            Case 2  '熱伝達
                kmat = NumMat(klayer)
                b1 = 2 * Rlamda(kmat, 1) / DxL(klayer)
                If ib = 1 Then
                    b2 = BoundDataL(1, 2) * BoundDataL(1, 1) + b1 * tempmesh
                    b3 = BoundDataL(1, 2) + b1
                Else
                    b2 = BoundDataR(1, 2) * BoundDataR(1, 1) + b1 * tempmesh
                    b3 = BoundDataR(1, 2) + b1
                End If
                temps = b2 / b3
            Case 3  '熱流束
                kmat = NumMat(klayer)
                If ib = 1 Then
                    b1 = BoundDataL(1, 1)
                Else
                    b1 = BoundDataR(1, 1)
                End If
                temps = tempmesh - b1 * DxL(klayer) / (2 * Rlamda(kmat, 1))
        End Select

    End Sub

    Private Sub Th1DCal3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, icc, icheck, icycle, ik, istep, iter, itmax, itime As Integer
        Dim kxcycle, mb, mbh, newstep, nk As Integer
        Dim df, drmesh, dtemp, rmesh, rmeshsum, sec As Single
        Dim date0, date1, date2 As Date
        Dim b1, dtempx, dtime0, dtime1, dtimestd As Double
        Dim time0, time1, time2, timenext As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        Me.Show()

        Call TimCal(0, timn$)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        Fw1 = 0 : Fw2 = 100

        Call ResFile1U()    '結果ﾌｧｲﾙへの出力1U

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Call InitialSet1()  '初期設定

        mb = 3      'ﾊﾞﾝﾄﾞ幅
        mbh = 2     'ﾊｰﾌﾊﾞﾝﾄﾞ幅
        ReDim Tk(Nall, mb)

        If Mstat = 0 Then   '定常解析
            Call DifMatrixS(mb)  '差分行列作成S
            Call Solver1(mbh, Nall)     'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
            Tf(Nall) = Tf(Nall) / Tk(Nall, mbh)
            Call Solver2(mbh, Nall)     'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
            For i = 1 To Nall
                Tu(i) = Tf(i)
            Next i
            Call BoundCalcS() '各境界温度の計算S
            Call ResFile3SU()  '結果ﾌｧｲﾙへの出力3SU
            Call ResFile4SU()  '結果ﾌｧｲﾙへの出力4SU

        Else    '非定常解析
            If Nstep = 1 Then
                df = (Fw2 - Fw1) / Ntime
                rmeshsum = Ntime     'ﾒｯｼｭ合計
            Else
                b1 = 0
                For i = 1 To Nstep
                    b1 = b1 + TimeStep(i)
                Next i
                rmeshsum = Ncycle * b1   'ﾒｯｼｭ合計
                df = (Fw2 - Fw1) / rmeshsum
            End If

            itime = 0
            TimeNew = 0
            icycle = 0
            istep = 0
            Call ResFile3U(itime, icycle, istep) '結果ﾌｧｲﾙへの出力3U

            Dim rdate As Date = Now
            date1 = rdate
            time1 = 0
            date2 = date1
            time2 = 0
            itime = 1
            icycle = 1
            Dtime = DtimeInit
            dtime0 = Dtime
            If Nstep = 1 Then
                dtimestd = TimeMax / Ntime
            Else
                dtimestd = TimeStep(1)
                kxcycle = Idcycle
                time0 = 0
                date0 = date1
            End If
            TimeNew = Dtime
            timenext = dtimestd
            newstep = 0
            istep = 1

            aa$ = "各時間ステップ計算中" + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)

            itmax = 20  '許容温度変化オーバーの修正計算最大回数
            nk = 10     '各時間ｽﾃｯﾌﾟにおける最大繰返し計算回数
            icheck = 0
            Do
                iter = 0
                Do
                    For ik = 1 To nk
                        Call DifMatrix(istep, mb)  '差分行列作成

                        'Call Debug1(mb)  '差分行列のデバッグ
                        Call Solver1(mbh, Nall)     'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
                        Tf(Nall) = Tf(Nall) / Tk(Nall, mbh)
                        Call Solver2(mbh, Nall)     'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
                        If ik > 1 Then
                            Call ConvCheck(icc, dtemp)  '収束ﾁｪｯｸ
                        End If
                        For i = 1 To Nall
                            Tu(i) = Tf(i)
                        Next i
                        If ik > 1 And icc > 0 Then
                            Exit For
                        End If
                    Next ik
                    Call DtempCalc(dtempx)      '最大温度変化の計算
                    If icc > 0 Then '収束
                        If dtempx < DtempMax Then
                            Exit Do
                        End If
                    End If
                    If iter = itmax Then
                        Exit Do
                    End If
                    iter = iter + 1

                    Dtime = 0.5 * Dtime
                    TimeNew = TimeNew - Dtime
                    dtime0 = Dtime
                    For i = 1 To Nall
                        Tu(i) = TUx(i)
                    Next i
                Loop

                Call BoundCalc(istep) '各境界温度の計算

                If Nstep = 1 Then
                    date0 = date1
                    time0 = time1
                End If
                date1 = date2
                time1 = time2
                Dim rdate1 As Date = Now
                date2 = rdate1
                time2 = TimeNew
                If TimeNew > 0.9999 * timenext Then
                    TimeNew = timenext
                    If Nstep = 1 Then
                        icc = 1
                    ElseIf icycle = kxcycle Then
                        icc = 1
                        If istep = Nstep Then
                            kxcycle = kxcycle + Idcycle
                            If kxcycle > Ncycle Then
                                kxcycle = Ncycle
                            End If
                        End If
                    Else
                        icc = 0
                    End If
                    If icc > 0 Then
                        Call ResFile3U(itime, icycle, istep)  '結果ﾌｧｲﾙへの出力3
                    End If

                    If Nstep = 1 Then
                        rmesh = itime
                    Else
                        drmesh = timenext - rmesh
                        rmesh = timenext
                    End If
                    If Nstep = 1 Then
                        b1 = time1 - time0
                        If b1 >= Dtime Then
                            sec = TimeLap(date0, date1)
                        Else
                            b1 = Dtime
                            sec = TimeLap(date1, date2)
                        End If
                    Else
                        b1 = time2 - time0
                        sec = TimeLap(date0, date2)
                    End If
                    Call ReqTime(rmesh, rmeshsum, b1, sec)   '残りの所要時間の計算

                    '進行表示
                    If Nstep = 1 Then
                        Fw1 = Fw1 + df
                    Else
                        Fw1 = Fw1 + drmesh * df
                    End If
                    ProgressBar1.Value = 100 * Fw1 / Fw2

                    If Nstep = 1 Then
                        itime = itime + 1
                        timenext = TimeMax * itime / Ntime
                    Else
                        If istep < Nstep Then
                            istep = istep + 1
                        Else
                            icycle = icycle + 1
                            istep = 1
                        End If
                        timenext = timenext + TimeStep(istep)
                        newstep = 1
                    End If
                End If

                If Nstep = 1 Then
                    If itime > Ntime Then
                        icheck = 1
                    End If
                ElseIf icycle > Ncycle Then
                    icheck = 1
                End If
                If icheck = 0 Then
                    If dtime0 < dtimestd Then
                        Call DtempCalc(dtempx)      '最大温度変化の計算
                        If dtime0 = Dtime Then
                            If dtempx = 0 Or dtempx < 0.5 * DtempMax Then
                                dtime0 = 2 * Dtime
                            End If
                            If dtime0 > 0.999 * dtimestd Then
                                dtime0 = dtimestd
                            End If
                        End If
                        For i = 1 To Nall
                            TUx(i) = Tu(i)
                        Next i
                    End If
                    dtime1 = timenext - TimeNew
                    If newstep = 0 Then
                        If dtime1 < 1.001 * dtime0 Then
                            Dtime = dtime1
                        Else
                            Dtime = dtime0
                        End If
                    Else
                        Dim rdate2 As Date = Now
                        date1 = rdate2
                        time1 = TimeNew
                        date2 = date1
                        time2 = 0
                        time0 = time1
                        date0 = date1
                        Dtime = DtimeInit
                        dtime0 = Dtime
                        dtimestd = TimeStep(istep)
                    End If
                    TimeNew = TimeNew + Dtime
                End If
                If NMdivMax > 1 Or newstep > 0 Then
                    newstep = 0
                End If

                aa$ = "ﾙｰﾌﾟ終了" + "   "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                Application.DoEvents()
            Loop Until icheck = 1

            Call ResFile4U()  '結果ﾌｧｲﾙへの出力4U

        End If

        '進行表示
        ProgressBar1.Value = 100

        Call TimCal(1, timn$)
        aa$ = "END   " & timn$
        SwK.WriteLine(aa$)
        SwK.Close()

        Label1.Text = "計算終了！"
        Label2.Text = "計算結果をファイルへ出力しました。"
        Label3.Text = aa$
        aa$ = "計算が終了しました。"
        Me.BringToFront()
        aa$ = aa$ + Chr(13) + Chr(10) + CalcRes$
        MsgBox(aa$, 0, "計算確認")

        gr.Clear(Color.White)
        gr.Dispose()
        Me.Close()

    End Sub
End Class
